//CODMW2Intervention.cs

//audio
datablock AudioProfile(rewardSound)
{
   filename    = "./MW2HS.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(CODMW2InterventionfireSound)
{
   filename    = "./CODMW2Interventionfire.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(CODMW2InterventionClipinSound)
{
   filename    = "./CODMW2InterventionClipin.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(CODMW2InterventionClipoutSound)
{
   filename    = "./CODMW2InterventionClipout.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(CODMW2InterventiondeploySound)
{
   filename    = "./CODMW2Interventiondeploy.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(CODMW2InterventionhitSound)
{
   filename    = "./CODBhit.wav";
   description = AudioClose3d;
   preload = true;
};

datablock DecalData(CODMW2InterventionDecal)
{
 textureName = "./CI_CODMW2Intervention";
};

datablock PlayerData(CODMW2InterventionArmor : PlayerStandardArmor)
{
	firstPersonOnly=1;

   runForce = 10 * 180;
   runEnergyDrain = 0;
   minRunEnergy = 0;
   maxForwardSpeed = 1.7;
   maxBackwardSpeed = 1.7;
   maxSideSpeed = 1.7;

   maxForwardCrouchSpeed = 0.8;
   maxBackwardCrouchSpeed = 0.6;
   maxSideCrouchSpeed = 0.6;

   jumpForce = 8 * 90; //8.3 * 90;
   jumpEnergyDrain = 0;
   minJumpEnergy = 0;
   jumpDelay = 0;

	minJetEnergy = 0;
	jetEnergyDrain = 0;
	canJet = 0;


	uiName = "";
	showEnergyBar = false;

   runSurfaceAngle  = 45;
   jumpSurfaceAngle = 45;
};

datablock ParticleData(CODMW2InterventionflashParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 25;
	lifetimeVarianceMS   = 15;
	textureName          = "./bullethole.png";
	spinSpeed		= 0.0;
	spinRandomMin		= 0.0;
	spinRandomMax		= 0.0;
	colors[0]     = "0.0 0.0 0.0 0.0";
	colors[1]     = "0.0 0.0 0.0 0.0";
	sizes[0]      = 0.5;
	sizes[1]      = 0.5;

	useInvAlpha = false;
};
datablock ParticleEmitterData(CODMW2InterventionflashEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 1.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 25;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "CODMW2InterventionflashParticle";

};

//Bullet Explosion
datablock ExplosionData(CODMW2Interventionexplosion)
{
   //explosionShape = "";
	soundProfile = CODMW2InterventionhitSound;

   lifeTimeMS = 150;

   particleEmitter = gunExplosionEmitter;
   particleDensity = 5;
   particleRadius = 0.2;

   emitter[0] = gunExplosionRingEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "10.0 10.0 10.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 0;
   lightEndRadius = 2;
   lightStartColor = "0.3 0.6 0.7";
   lightEndColor = "0 0 0";
};


datablock ExplosionData(InterventionMW2weaponRecoilExplosion)
{
  lifeTimeMS = 10;
  explosionScale = "1 0 1";
  shakeCamera = true;
  camShakeFreq = "1 0 1";
  camShakeAmp = "1 0 1";
  camShakeDuration = 10;
  camShakeRadius = 0.5;
};

datablock ProjectileData(InterventionMW2weaponRecoil)
{
  uiName = "";
  explosion = InterventionMW2weaponRecoilExplosion;
  muzzleVelocity = 0;
  velInheritFactor = 1;
  lifetime = 1;
  fadeDelay = 1;
  explodeOnDeath = true;
};


AddDamageType("CODMW2Intervention",   '<bitmap:add-ons/Weapon_CODMW2Intervention/CI_CODMW2Intervention> %1',    '%2 <bitmap:add-ons/Weapon_CODMW2Intervention/CI_CODMW2Intervention> %1',0.2,1);
datablock ProjectileData(CODMW2Interventionprojectile)
{
   projectileShapeName = "Add-Ons/Weapon_Gun/bullet.dts";
   directDamage        = 100;
   directDamageType    = $DamageType::CODMW2Intervention;
   radiusDamageType    = $DamageType::CODMW2Intervention;

   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 35;
   verticalImpulse	  = 2;
   explosion           = CODMW2InterventionExplosion;
   particleEmitter     = ""; //bulletTrailEmitter;

   muzzleVelocity      = 200;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 3000;
   fadeDelay           = 2500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.2;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

};


AddDamageType("CODMW2Interventions",   '<bitmap:add-ons/Weapon_CODMW2Intervention/CI_CODMW2Intervention> %1',    '%2 <bitmap:add-ons/Weapon_CODMW2Intervention/CI_CODMW2Intervention> %1',0.2,1);
datablock ProjectileData(CODMW2Interventionsprojectile)
{
   projectileShapeName = "Add-Ons/Weapon_Gun/bullet.dts";
   directDamage        = 100;
   directDamageType    = $DamageType::CODMW2Interventions;
   radiusDamageType    = $DamageType::CODMW2Interventions;

   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 35;
   verticalImpulse	  = 2;
   explosion           = CODMW2InterventionExplosion;
   particleEmitter     = ""; 

   muzzleVelocity      = 200;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 3000;
   fadeDelay           = 2500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.2;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

   uiName = "CODMW2Intervention Bullet";
};


AddDamageType("CODMW2InterventionH",   '<bitmap:add-ons/Weapon_CODMW2Intervention/CI_CODMW2Intervention> %1',    '%2 <bitmap:add-ons/Weapon_CODMW2Intervention/CI_CODMW2Intervention> %1',0.2,1);
datablock ProjectileData(CODMW2InterventionHprojectile)
{
   projectileShapeName = "Add-Ons/Weapon_Gun/bullet.dts";
   directDamage        = 100;
   directDamageType    = $DamageType::CODMW2InterventionH;
   radiusDamageType    = $DamageType::CODMW2InterventionH;

   brickExplosionRadius = 0;
   brickExplosionImpact = false;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 35;
   verticalImpulse	  = 2;
   explosion           = CODMW2InterventionExplosion;
   particleEmitter     = ""; 

   muzzleVelocity      = 200;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 3000;
   fadeDelay           = 2500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.2;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

   uiName = "CODMW2Intervention Bullet";
};

//////////
// item //
//////////
datablock ItemData(CODMW2InterventionItem)
{
	category = "Weapon";
	className = "Weapon"; 

	 // Basic Item Properties
	shapeFile = "./BrCODMW2Intervention.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "MW2 Intervention";
	iconName = "./Icon_CODMW2Intervention";
	doColorShift = true;
	colorShiftColor = "0.25 0.25 0.25 1.000";

	 // Dynamic properties defined by the scripts
	image = CODMW2InterventionImage;
	canDrop = true;
	
	//Ammo Guns Parameters
	maxAmmo = 5;
	canReload = 1;
};

datablock ShapeBaseImageData(CODMW2InterventionImage)
{
   // Basic Item properties
   shapeFile = "./CODMW2Intervention.dts";
   emap = true;
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0;
   rotation = eulerToMatrix( "0 0 0" );
   correctMuzzleVector = true;
   className = "WeaponImage";
   item = CODMW2InterventionItem;
   ammo = " ";
   projectile = CODMW2Interventionprojectile;
   projectileType = Projectile;

	casing = gunShellDebris;
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;
   melee = false;
   armReady = true;

   doColorShift = true;
   colorShiftColor = CODMW2InterventionItem.colorShiftColor;
   // Initial start up state - Ammo mod by Space Guy, base states taken from L4Pistol by Bushido!
	stateName[0]                    = "Activate";
	stateTimeoutValue[0]            = 0.3;
	stateTransitionOnTimeout[0]     = "LoadCheckA";

	stateName[1]                    = "Ready";
	stateTransitionOnNoAmmo[1]	= "ClipOut";
	stateTransitionOnTriggerDown[1] = "Fire";
	stateAllowImageChange[1]        = true;
	stateSequence[1]			  = "ready";

	stateName[2]                    = "Fire";
	stateTimeoutValue[2]            = 1.6;
	stateTransitionOnTimeout[2]     = "Smoke";
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateScript[2]                  = "onFire";
	stateSequence[2]		= "Fire";
	stateWaitForTimeout[2]		= true;
	stateEmitter[2]			= CODMW2InterventionflashEmitter;
	stateEmitterTime[2]		= 0.05;
	stateEmitterNode[2]		= "muzzleNode";
	stateSound[2]			= CODMW2InterventionfireSound;
	stateEjectShell[2]              = true;

	stateName[3] 			= "Smoke";
	stateEmitter[3]			= gunSmokeEmitter;
	stateEmitterTime[3]		= 0.1;
	stateTimeoutValue[3]	= 0.03;
	stateEmitterNode[3]		= "muzzleNode";
	stateTransitionOnTimeout[3]	= "FireLoadCheckA";

	stateName[4]			= "Wait";
	stateTimeoutValue[4]		= 0.03;
	stateScript[4]                  = "";
	stateTransitionOnTriggerUp[4] = "Delay";
	
	stateName[5]				= "LoadCheckA";
	stateScript[5]				= "onLoadCheck";
	stateTimeoutValue[5]			= 0.01;
	stateTransitionOnTimeout[5]		= "LoadCheckB";
	
	stateName[6]				= "LoadCheckB";
	stateTransitionOnAmmo[6]		= "ReadyWeap";
	stateTransitionOnNoAmmo[6]		= "ReloadWait";
	
	stateName[7]				= "ReloadWait";
	stateTimeoutValue[7]			= 0.5;
	stateScript[7]				= "";
	stateTransitionOnTimeout[7]		= "ClipOut";

	stateName[8]				= "ClipOut";
	stateTimeoutValue[8]			= 1.0;
	stateScript[8]				= "onReloadStart";
	stateSequence[8]		= "ClipOut";
	stateAllowImageChange[8]        = true;
	stateTransitionOnTimeout[8]		= "ClipIn";
	stateSound[8]				= CODMW2InterventionclipoutSound;
	
	stateName[9]				= "ClipIn";
	stateTimeoutValue[9]			= 1.0;
	stateScript[9]				= "";
	stateSequence[9]		= "ClipIn";
	stateAllowImageChange[9]        = true;
	stateTransitionOnTimeout[9]		= "reloadFinish";
	stateSound[9]				= CODMW2InterventionclipinSound;
	
	stateName[10]				= "reloadFinish";
	stateTimeoutValue[10]			= 0.2;
	stateScript[10]				= "onReloaded";
	stateAllowImageChange[10]        = true;
	stateTransitionOnTimeout[10]		= "Ready";
	
	stateName[11]				= "FireLoadCheckA";
	stateScript[11]				= "onLoadCheck";
	stateTimeoutValue[11]			= 0.01;
	stateTransitionOnTimeout[11]		= "FireLoadCheckB";
	
	stateName[12]				= "FireLoadCheckB";
	stateTransitionOnAmmo[12]		= "Wait";
	stateTransitionOnNoAmmo[12]		= "ReloadWait";
	
	stateName[13]				= "Delay";
	stateTransitionOnTimeout[13]		= "Ready";
	stateTimeoutValue[13] 			= 0.00001;
	
	stateName[14]				= "ReadyWeap";
	stateSequence[14]			= "Use";
	stateTimeoutValue[14] 			= 0.8;
	stateSound[14]			= CODMW2InterventiondeploySound;
	stateTransitionOnTimeout[14]		= "Ready";
};
datablock ShapeBaseImageData(CODMW2InterventionSightsImage)
{
   shapeFile = "./CODMW2Intervention.dts";
   emap = true;

   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = "-0.6428 -1.0 -2.02064";
   rotation = eulerToMatrix( "0 0 0" );

   correctMuzzleVector = true;

   className = "WeaponImage";

   item = CODMW2InterventionItem;
   ammo = " ";
   projectile = CODMW2Interventionsprojectile;
   projectileType = Projectile;

	casing = gunShellDebris;
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;
	shellVelocity       = 7.0;

   melee = false;
   armReady = true;
   canDrop = true;

   doColorShift = true;
   colorShiftColor = CODMW2InterventionItem.colorShiftColor;
   
	stateName[0]                    = "Activate";
	stateTimeoutValue[0]            = 0.5;
	stateTransitionOnTimeout[0]     = "LoadCheckA";

	stateName[1]                    = "Ready";
	stateTransitionOnNoAmmo[1]	= "reloadSequence";
	stateTransitionOnTriggerDown[1] = "Fire";
	stateAllowImageChange[1]        = true;
	stateSequence[1]			  = "ready";

	stateName[2]                    = "Fire";
	stateTimeoutValue[2]            = 1.6;
	stateTransitionOnTimeout[2]     = "Smoke";
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateScript[2]                  = "onFire";
	stateSequence[2]		= "ADSFire";
	stateWaitForTimeout[2]		= true;
	stateEmitter[2]			= CODMW2InterventionflashEmitter;
	stateEmitterTime[2]		= 0.03;
	stateEmitterNode[2]		= "muzzleNode";
	stateSound[2]			= CODMW2InterventionfireSound;

	stateName[3] 			= "Smoke";
	stateEmitter[3]			= gunSmokeEmitter;
	stateEmitterTime[3]		= 0.1;
	stateTimeoutValue[3]		= 0.04;
	stateEmitterNode[3]		= "muzzleNode";
	stateTransitionOnTimeout[3] = "FireLoadCheckA";

	stateName[4]			= "Wait";
	stateEjectShell[2]              = true;
	stateTimeoutValue[4]		= 0.05;
	stateScript[4]                  = "";
	stateTransitionOnTriggerUp[4] = "Delay";
	
	stateName[5]				= "LoadCheckA";
	stateScript[5]				= "onLoadCheck";
	stateTimeoutValue[5]			= 0.01;
	stateTransitionOnTimeout[5]		= "LoadCheckB";
	
	stateName[6]				= "LoadCheckB";
	stateTransitionOnAmmo[6]		= "Ready";
	stateTransitionOnNoAmmo[6]		= "ReloadWait";
	
	stateName[7]				= "ReloadWait";
	stateTimeoutValue[7]			= 0.3;
	stateScript[7]				= "";
	stateTransitionOnTimeout[7]		= "reloadSequence";
	
	stateName[8]				= "reloadSequence";
	stateScript[8]				= "setInterventionZorro";
	
	stateName[9]				= "FireLoadCheckA";
	stateScript[9]				= "onLoadCheck";
	stateTimeoutValue[9]			= 0.01;
	stateTransitionOnTimeout[9]		= "FireLoadCheckB";
	
	stateName[10]				= "FireLoadCheckB";
	stateTransitionOnAmmo[10]		= "Wait";
	stateTransitionOnNoAmmo[10]		= "ReloadWait";
	
	stateName[11]				= "Delay";
	stateTransitionOnTimeout[11]		= "Ready";
	stateTimeoutValue[11]			= 0.106;
};

datablock ShapeBaseImageData(CODMW2InterventionBackImage)
{
  shapeFile = "./BrCODMW2Intervention.dts";
  emap = true;
  mountPoint = $BackSlot;
  offset = "0.2 -0.35 0.3";
  eyeOffset = "0 0 10";
  rotation = eulerToMatrix("-75 0 90");
  armReady = false;
  doColorShift = false;
};

function CODMW2Intervention2SpawnProj(%this,%obj,%slot)
{
	if(vectorLen(%obj.getVelocity()) < 0.5 && (getSimTime() - %obj.lastShotTime) > 500)
		%spread = 0.0000;
	else
		%spread = 0.0000;
	if(vectorLen(%obj.getVelocity()) < 1 && (getSimTime() - %obj.lastShotTime) > 600 && %obj.getMountedImage(0) == nameToID(CODMW2InterventionSightsImage))
		%spread = 0.0000;
	else if(vectorLen(%obj.getVelocity()) < 1 && (getSimTime() - %obj.lastShotTime) > 1150 && %obj.getMountedImage(0) == nameToID(CODMW2InterventionSightsImage))
		%spread = 0.0000;

	%p = new (%this.projectileType)()
	{
    	  dataBlock = InterventionMW2weaponRecoil;
    	  initialVelocity = VectorAdd(%vector1,%vector2);
    	  initialPosition = %obj.getEyePoint();
    	  sourceObject = %obj;
    	  sourceSlot = %slot;
    	  client = %obj.client;
  	};
	%projectile = CODMW2Interventionsprojectile;
	%shellcount = 1;
        	%obj.toolAmmo[%obj.currTool]--;
	%obj.lastShotTime = getSimTime();

	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);

		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
	}
	return %p;
}


function CODMW2InterventionSightsImage::setInterventionZorro(%this,%obj,%slot)
{
	%newAmmo = %obj.toolAmmo[%obj.currTool];
	%obj.mountImage(CODMW2InterventionImage, 0, 0, 0);
	%obj.toolAmmo[%obj.currTool] = %newAmmo;
}

function CODMW2InterventionSightsImage::onFire(%this,%obj,%slot)
{	
	if(%obj.client.quantity["InterReloadAmmo"] < 1)
    	{
    	%obj.client.quantity["InterReloadAmmo"] = 0;
    	}

    	if(%obj.client.quantity["InterReloadAmmo"] > 24)
    	{
		%obj.client.quantity["InterReloadAmmo"] = 24;
	}

      	%obj.client.quantity["InterReloadCount"] += 1; 
      	commandToClient(%obj.client,'bottomPrint',"<just:right>\c6Ammo: " @ %obj.toolAmmo[%obj.currTool] @ " | " @ %obj.client.quantity["InterReloadAmmo"] @ "", 1, 2, 3, 4);


	if(%obj.toolAmmo[%obj.currTool] > 0)
	{
		CODMW2Intervention2SpawnProj(%this,%obj,%slot);
	}
	else if(%this.item.maxAmmo == 0)
	{
		CODMW2Intervention2SpawnProj(%this,%obj,%slot);
	}
}


function CODMW2InterventionImage::onFire(%this,%obj,%slot)
{
	%obj.playThread(2, plant);

    	if(%obj.client.quantity["InterReloadAmmo"] > 24)
    	{
		%obj.client.quantity["InterReloadAmmo"] = 24;
	}

	if(%obj.toolAmmo[%obj.currTool] > 0)
	{
		CODMW2InterventionSpawnProj(%this,%obj,%slot);
	}
	else if(%this.item.maxAmmo == 0)
	{
		CODMW2InterventionSpawnProj(%this,%obj,%slot);
	}
}

function CODMW2InterventionImage::onLoadCheck(%this,%obj,%slot)
{
		if(%obj.client.quantity["InterReloadAmmo"] < 1)
    		{
    		%obj.client.quantity["InterReloadAmmo"] = 0;
    		}
	
		%obj.client.quantity["InterReloadCount"] += 1;
      		commandToClient(%obj.client,'bottomPrint',"<just:right>\c6Ammo: " @ %obj.toolAmmo[%obj.currTool] @ " | " @ %obj.client.quantity["InterReloadAmmo"] @ "", 1, 2, 3, 4);


		if(%obj.toolAmmo[%obj.currTool] <= 0 && %this.item.maxAmmo > 0 && %obj.getState() !$= "Dead")
		{	
                        %obj.setImageAmmo(%slot,0);
		}
		else
		{
			%obj.setImageAmmo(%slot,1);
		}
}
	

function CODMW2InterventionImage::onReloadStart(%this,%obj,%slot)
{
    if(%obj.client.quantity["InterReloadAmmo"] == 0)
    {
    commandToClient(%obj.client,'bottomPrint',"<just:right>\c6Ammo: " @ %obj.toolAmmo[%obj.currTool] @ " | " @ %obj.client.quantity["InterReloadAmmo"] @ "", 1, 2, 3, 4);
    return;
    }
	%obj.toolAmmo[%obj.currTool] = 0;
	%client.setControlCameraFov(90);
}


function CODMW2InterventionImage::onReloaded(%this,%obj,%slot)
{

	if(%obj.client.quantity["InterReloadAmmo"] >= 1)
        {
        if(%obj.client.quantity["InterReloadAmmo"] >= 5)
            {
            %obj.client.quantity["InterReloadAmmo"] -= %obj.client.quantity["InterReloadCount"];
	        %obj.toolAmmo[%obj.currTool] = %this.item.maxAmmo;
	        %obj.setImageAmmo(%slot,1);
            if(%obj.client.quantity["InterReloadAmmo"] < 1)
            {
            %obj.client.quantity["InterReloadAmmo"] = 0;
            }
            if(%obj.toolAmmo[%obj.currTool] >= 6)
            {
            %obj.toolAmmo[%obj.currTool] = 5;
            }
            commandToClient(%obj.client,'bottomPrint',"<just:right>\c6Ammo: 6 | " @ %obj.client.quantity["InterReloadAmmo"] @ "", 1, 2, 3, 4); 
            %obj.client.quantity["InterReloadCount"] = 0;
            }
        else
            {
	        %obj.toolAmmo[%obj.currTool] += %obj.client.quantity["InterReloadAmmo"];  
	        %obj.setImageAmmo(%slot,1);
            %obj.client.quantity["InterReloadAmmo"] = 0;
            if(%obj.client.quantity["InterReloadAmmo"] < 1)
            {
            %obj.client.quantity["InterReloadAmmo"] = 0;
            }
            if(%obj.toolAmmo[%obj.currTool] >= 6)
            {
            %obj.toolAmmo[%obj.currTool] = 5;
            }
            commandToClient(%obj.client,'bottomPrint',"<just:right>\c6Ammo: " @ %obj.toolAmmo[%obj.currTool] @ " | " @ %obj.client.quantity["InterReloadAmmo"] @ "", 1, 2, 3, 4); 
            %obj.client.quantity["InterReloadCount"] = 0;
            }
        }
    else
        {
        messageClient(%client,'','\c3Man, You ain\'t got the weapon for this');
        }

}

function CODMW2Interventionmage::onReloadWait(%this,%obj,%slot)
{
    if(%obj.client.quantity["InterReloadAmmo"] == 0)
    {
    commandToClient(%obj.client,'bottomPrint',"<just:right>\c6Ammo: " @ %obj.toolAmmo[%obj.currTool] @ " | " @ %obj.client.quantity["InterReloadAmmo"] @ "", 1, 2, 3, 4);
    return;
    }
}

function CODMW2InterventionSpawnProj(%this,%obj,%slot)
{
	if(vectorLen(%obj.getVelocity()) < 0.5 && (getSimTime() - %obj.lastShotTime) > 500)
		%spread = 0.005;
	else
		%spread = 0.02;
	if(vectorLen(%obj.getVelocity()) < 1 && (getSimTime() - %obj.lastShotTime) > 600 && %obj.getMountedImage(0) == nameToID(CODMW2InterventionSightsImage))
		%spread = 0.01;
	else if(vectorLen(%obj.getVelocity()) < 1 && (getSimTime() - %obj.lastShotTime) > 1150 && %obj.getMountedImage(0) == nameToID(CODMW2InterventionSightsImage))
		%spread = 0.008;


	%projectile = CODMW2Interventionprojectile;
	%shellcount = 1;
        	%obj.toolAmmo[%obj.currTool]--;
	%obj.lastShotTime = getSimTime();

	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);

		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
	}
	return %p;
}

function CODMW2InterventionItem::onPickup(%this,%obj,%col,%a)
{
  for(%i=0;%i<%col.getdatablock().maxTools;%i++)
  {
    %item = %col.tool[%i];
    if(%item $= 0 || %item $= "")
    {
      %freeSlot = 1;
      break;
    }
  }
  if(%obj.canpickup && !isobject(%col.getmountedimage(1)) && %freeSlot) { %col.mountimage(CODMW2InterventionBackImage,1); }
  parent::onPickup(%this,%obj,%col,%a);
}

package CODMW2InterventionPackage
{
  function servercmdDropTool(%this,%slot)
  {
    if(isobject(%this.player.tool[%slot]) && %this.player.tool[%slot].getname() $= "CODMW2InterventionItem")
    {
      parent::servercmdDropTool(%this,%slot);
      if(isobject(%this.player.getmountedimage(1)) && %this.player.getmountedimage(1).getname() $= "CODMW2InterventionBackImage") { %this.player.schedule(5,unmountimage,1); }
      return;
    }
    parent::servercmdDropTool(%this,%slot);
  }
};


function CODMW2InterventionImage::onMount(%this, %obj, %slot)
{		
	parent::onMount(%this,%obj,%slot); 
	%obj.hideNode("LHand"); 
	%obj.hideNode("RHand"); 
  	if(%obj.getMountedImage(1).getName() $= "CODMW2InterventionBackImage") { %obj.unMountImage(1); }
}


function CODMW2InterventionImage::onUnMount(%this, %obj, %slot)
{	
	parent::onUnMount(%this,%obj,%slot);
	%obj.unhidenode("RHand");
       	%obj.unhidenode("LHand");
  	%obj.unMountImage(1);
  	%obj.mountImage(CODMW2InterventionBackImage,1);
}



function CODMW2InterventionSightsImage::onMount(%this, %obj, %slot)
{	

	%client = %obj.client;
	%client.player.setDataBlock("CODMW2InterventionArmor"); 


}


function CODMW2InterventionSightsImage::onUnMount(%this, %obj, %slot)
{	

	%client = %obj.client;
		if(!isObject(%client.minigame))
		{
			%client.player.setDataBlock("PlayerStandardArmor");
		}
		else
		{
			%client.player.setdatablock(%client.minigame.playerDatablock);
		}

}

registerOutputEvent("Player", "Refill_InterventionAmmo");

function Player::Refill_InterventionAmmo(%obj, %client)
{
    %obj.toolAmmo[%obj.currTool] = 5;
    %obj.client.quantity["InterReloadAmmo"] += 5;
    %obj.client.quantity["InterReloadCount"] = 0;
    commandToClient(%obj.client,'centerPrint',"<just:right>\c6Intervention \c3Ammo \c6picked up", 1, 2, 3, 4);
    if(%obj.client.quantity["InterReloadAmmo"] > 25)
    {
	
	%obj.client.quantity["InterReloadAmmo"] = 25;

    }  
}

function CODMW2Interventionprojectile::Damage(%this, %obj, %col, %fade, %pos, %normal)
{
   if(%col.getClassName() $="Player" || %col.getClassName() $= "AIPlayer") 
   {
      if(%col.getClassName() $= "AIPlayer")
      {
         %oldClient = %col.client; 
         %col.client = BotConnection;
         %hitBoxList = getHitbox(%obj, %col, %pos);
         %col.client = %oldClient;
      }
      else
      {
         %hitBoxList = getHitbox(%obj, %col, %pos);
      }
      if(strReplace(%hitBoxList, "headskin", "BAM") $= %hitBoxList)
      {
         parent::Damage(%this, %obj, %col, %fade, %pos, %normal);
      }
      else
      {
         %obj.client.centerPrint("\c6x",3);
         %obj.client.play2D(rewardSound);
         %col.damage(%obj, %pos, (125 * getWord(%obj.getScale(),2)), $DamageType::CODMW2InterventionHeadshot);
      }
   }
   else
   {
      parent::Damage(%this, %obj, %col, %fade, %pos, %normal);
   }
}

function CODMW2Interventionsprojectile::Damage(%this, %obj, %col, %fade, %pos, %normal)
{
   if(%col.getClassName() $="Player" || %col.getClassName() $= "AIPlayer") 
   {
      if(%col.getClassName() $= "AIPlayer")
      {
         %oldClient = %col.client; 
         %col.client = BotConnection;
         %hitBoxList = getHitbox(%obj, %col, %pos);
         %col.client = %oldClient;
      }
      else
      {
         %hitBoxList = getHitbox(%obj, %col, %pos);
      }
      if(strReplace(%hitBoxList, "headskin", "BAM") $= %hitBoxList)
      {
         parent::Damage(%this, %obj, %col, %fade, %pos, %normal);
      }
      else
      {
         %obj.client.centerPrint("\c6x",3);
         %obj.client.play2D(rewardSound);
         %col.damage(%obj, %pos, (125 * getWord(%obj.getScale(),2)), $DamageType::CODMW2InterventionH);
      }
   }
   else
   {
      parent::Damage(%this, %obj, %col, %fade, %pos, %normal);
   }
}

package CODMW2InterventionSightsSwitch
{
	function armor::onTrigger(%this, %obj, %triggerNum, %val)
	{
		%client = %obj.client;
		if(%triggerNum == 4 && %obj.isImageMounted(CODMW2InterventionImage) && %val && %obj.toolAmmo[%obj.currTool] != 0)
		{
			%newAmmo = %obj.toolAmmo[%obj.currTool];
			%obj.mountImage(CODMW2InterventionSightsImage, 0, 0, 0);
			%obj.toolAmmo[%obj.currTool] = %newAmmo;
			%client.setControlCameraFov(20);
		}
		else if(%triggerNum == 4 && %obj.isImageMounted(CODMW2InterventionSightsImage) && %val)
		{
			%newAmmo = %obj.toolAmmo[%obj.currTool];
			%obj.mountImage(CODMW2InterventionImage, 0, 0, 0);
			%obj.toolAmmo[%obj.currTool] = %newAmmo;
			%client.setControlCameraFov(90);
	         
		}

		Parent::onTrigger(%this, %obj, %triggerNum, %val);
	}
};
activatePackage(CODMW2InterventionSightsSwitch);
activatepackage(CODMW2InterventionPackage);












